#! /bin/awk -f

#####
#
# integ00.awk
# MDJ 2022/03/26
#
# Universal Version Step Two:
#   Check the integrity of the
a   file identified on the
#   command line. 
#
# To Run:
#   cdCoCo
#   cd wk00
#   integ00.awk filename
#
#####

BEGIN {
	BNn = 0   # Block Number Counter
	BN = "00" # Block Number Counter Display
	print " "
	print "Beginning of Integrity Test"
	print " "
}

{

	# First Block
	# First Line of Block
	#  = Question Number Comment Line

	# Truncate $NF to remove trailing "\n"
	NFT = substr($NF,1,2)
	
	# Convert NFT string to numeric
	NFn = 0 + NFT
	
	# Convert BNn Counter to string
	if ( BNn < 10 )
	{
		BN = "0" BNn
	}
	else
	{
		BN = "" BNn
	}
	
	if ( NFn == BNn )
	{
		print "Match " BN " " NFT
		print $0
	}
	else
	{
		print "No Match " BN " " NFT " ERROR!"
		print $0
		exit 1
	}
	
	# Question Line
	getline
	print $0
	
	# Correct Answer Line
	getline
	print $0
	
	# Incorrect Answer #1 Line
	getline
	print $0
	
	# Incorrect Answer #2 Line
	getline
	print $0
	
	# Incorrect Answer #3 Line
	getline
	print $0
	
	# Incorrect Answer #4 Line
	getline
	print $0
	
	# Blank Line
	getline
	print $0
	
	# Blocks 2 through last:
	# Question Number Comment Line
	while ( 1 == 1 )
	{
		r = getline
		# If EOF:
		if (r <= 0)
		{
			exit 0
		}
		else
		{
			BNn = BNn + 1
	
			# Truncate $NF to remove trailing "\n"
			NFT = substr($NF,1,2)
	
			# Convert NFT string to numeric
			NFn = 0 + NFT
	
			# Convert BNn Counter to string
			if ( BNn < 10 )
			{
				BN = "0" BNn
			}
			else
			{
				BN = "" BNn
			}
		
			if ( NFn == BNn )
			{
				print "Match " BN " " NFT
				print $0
			}
			else
			{
				print "No Match " BN " " NFT " ERROR!"
				print $0
				exit 1
			}
		}
		
		# Question Line
		getline
		print $0
		
		# Correct Answer Line
		getline
		print $0
		
		# Incorrect Answer #1 Line
		getline
		print $0
		
		# Incorrect Answer #2 Line
		getline
		print $0
		
		# Incorrect Answer #3 Line
		getline
		print $0
		
		# Incorrect Answer #4 Line
		getline
		print $0
		
		# Blank Line
		getline
		print $0
	}
}

END { 
	print "End of Integrity Test" 
	print " "
}

#####
#
# EOF
#
#####
